#------------------------------
# Exercise 1
#------------------------------

#------------------------------
# Question a

pi<-0.90
mu<-2
sig<- 1
a=10;
c<-1/(2*a)
n<- 100

w<-vector("numeric",n)
z<-w
for(i in 1:n){
	z[i]=sample(c(1,0),size=1,prob=c(pi,1-pi))
	if(z[i]==1){
		w[i]<- rnorm(1,mean=mu,sd=sig)
	}
	else{
		w[i]<-runif(1,min=-a,max=a)
	}
}

boxplot(w)
dotchart(w)
#------------------------------
# Question b

# Observed data Loglikelihood
loglik<- function(theta,w){
	phi <- sapply(w,dnorm,mean=theta[1],sd=theta[2])
	logL <- sum(log(theta[3]*phi+(1-theta[3])*c))
	return(logL)
}

# EM algoritm
em_outlier <- function(w,theta0,a,epsi){
	go_on<-TRUE
	logL0<- loglik(theta0,w)
	t<-0
	c<-1/(2*a)
	n<-length(w)
	print(c(t,logL0))
	while(go_on){
		t<-t+1
		# E-step
		phi <- sapply(w,dnorm,mean=theta0[1],sd=theta0[2])
		z<-  phi*theta0[3]/(phi*theta0[3]+c*(1-theta0[3]))
		# M-step
		S<- sum(z)
		pi<-S/n
		mu<- sum(w*z)/S
		sig<-sqrt(sum(z*(w-mu)^2)/S)
		theta<-c(mu,sig,pi)
		logL<-loglik(theta,w) 
		if (logL-logL0 < epsi){
			go_on <- FALSE
			}
		logL0 <- logL
		theta0<-theta
		print(c(t,logL))
		}
	return(list(loglik=logL,theta=theta,z=z))
}

#------------------------------
# Question c

mu0<-mean(w) # +rnorm(1,mean=0,sd=0.5)
sig0<-sd(w)
pi0<-0.5
epsi<-1e-6
theta0<-c(mu0,sig0,pi0)
estim<-em_outlier(w,theta0,a,epsi)

plot(w,1-estim$z)



#------------------------------
# Question d

opt<-optim(theta0, loglik, gr = NULL,method = "BFGS", 
           hessian = FALSE,control=list(fnscale=-1),w=w)

print(opt$par)     # estimates computed with optim
print(estim$theta)  # estimates computed with EM


#------------------------------
# Exercise 2
#------------------------------

#------------------------------
# Question a


pi<-0.5
beta<-c(1,2)
sig<- 2
a=20;
c<-1/(2*a)
n<- 100

w<-vector("numeric",n)
v <- runif(n,min=-6,max=6)
z<-w
for(i in 1:n){
	z[i]=sample(c(1,0),size=1,prob=c(pi,1-pi))
	if(z[i]==1){
		w[i]<- rnorm(1,mean=beta[1]+v[i]*beta[2],sd=sig)
	}
	else{
		w[i]<-runif(1,min=-a,max=a)
	}
}

plot(v,w)
points(v[z==0],w[z==0],pch=16)

#------------------------------
# Question b

reg<-lm(w~v)
abline(reg,lty=2) # LS line
abline(1,2,lty=1) # regression line

#------------------------------
# Question c

loglik_reg<- function(theta,w,v){
	n<-length(w)
	phi<-vector(n,mode="numeric")
	for(i in 1:n){
		phi[i] <- dnorm(w[i],mean=theta[1]+theta[2]*v[i],sd=theta[3])
		}
	logL <- sum(log(theta[4]*phi+(1-theta[4])*c))
	return(logL)
}

em_outlier_reg <- function(w,v,theta0,a,epsi){
	go_on<-TRUE
	logL0<- loglik_reg(theta0,w,v)
	t<-0
	c<-1/(2*a)
	n<-length(w)
	phi<-vector(n,mode="numeric")
	print(c(t,logL0))
	while(go_on){
		t<-t+1
		# E-step
		for(i in 1:n){
			phi[i] <- dnorm(w[i],mean=theta0[1]+theta0[2]*v[i],sd=theta0[3])
			}
		z<-  phi*theta0[4]/(phi*theta0[4]+c*(1-theta0[4]))
		# M-step
		S<- sum(z)
		pi<-S/n
		reg<-lm(w ~v,weights=z)
		beta<-reg$coefficients
		sig<-sqrt(sum(z*reg$residuals^2)/S)
		theta<-c(beta,sig,pi)
		logL<-loglik_reg(theta,w,v) 
		if (logL-logL0 < epsi){
			go_on <- FALSE
			}
		logL0 <- logL
		theta0<-theta
		print(c(t,logL))
		}
	return(list(loglik=logL,theta=theta,z=z))
}

#------------------------------
# Question d

beta0<-reg$coefficients
sig0<-sd(reg$residuals)
pi0<-0.8
epsi<-1e-6
theta0<-c(beta0,sig0,pi0)

estim<-em_outlier_reg(w,v,theta0,a,epsi)

plot(v,w)
abline(reg,lty=2) # LS line
abline(1,2,lty=1) # regression line
abline(estim$theta[1],estim$theta[2],lty=3) # line estimated using EM

points(v[estim$z<0.5],w[estim$z<0.5],pch=19)


